import { buildUUID } from '../../../utils/uuid';
import { ApiAction, ApiActionPage } from '../../model/baseModel';
import {
  Tsk_JobListItem,
  Tsk_JobPageListGetResultModel,
  Tsk_JobPageParams,
  Tsk_TrigListItem,
} from '../model/tskModel';
import { genAction,genActionjob, Api, genActionPage } from '../system';
import { defHttp } from '/@/utils/http/axios';
import { useGlobSetting } from '/@/hooks/setting';

const globSetting = useGlobSetting();
/*
 * 获取角色分页列表
 */
export const getTsk_JobListByPage = async (params: Tsk_JobPageParams) => {
  var id='';
  if(params?.Status != undefined && params?.Status != ''){
    let sqlcmdt='';
    sqlcmdt += " STATUS = '" + params?.Status + "'";;
    const _data = await defHttp.post<ApiAction<Tsk_TrigListItem[]>>(
      { url: Api.EntityList, params: genAction('TSK_TRIG', sqlcmdt) },
      {
        isTransformResponse: false,
        apiUrl: globSetting.taskApiUrl
      },
    );
   let sqlcmd='';
   _data.Data.forEach((item,index) => {
    if(index==0){
      sqlcmd+="and ID='"+item.JobId+"'"
    }else{
      sqlcmd+="Or ID='"+item.JobId+"'"
    }
    
   });
   const rParams = genActionPage('TSK_JOB', sqlcmd, params.page, params.pageSize);
   return getTsk_JobListByPageAsync(rParams);
  }else{
    let sqlcmd = '';
    if (id!= undefined && id != '') {
      sqlcmd += " And ID = '" + id + "'";
    }
    if (params?.JobName != undefined && params?.JobName != '') {
      sqlcmd += " And JobName like '%" + params?.JobName + "%'";
    }
    if (params?.CREATE_TIME != undefined && params?.CREATE_TIME != '') {
      sqlcmd += "And CREATE_TIME > '" + params?.CREATE_TIME[0]+"'";
    }
    if (params?.CREATE_TIME != undefined && params?.CREATE_TIME != '') {
      sqlcmd += "And CREATE_TIME < '" + params?.CREATE_TIME[1]+"'";
    }
    const rParams = genActionPage('TSK_JOB', sqlcmd, params.page, params.pageSize);
    return getTsk_JobListByPageAsync(rParams);
  }
};
async function getTsk_JobListByPageAsync(params: ApiActionPage) {
  const data = await defHttp.post<ApiActionPage>(
    { url: Api.EntityPageList, params },
    {
      isTransformResponse: false,
      apiUrl: globSetting.taskApiUrl
    },
  );
  const model: Tsk_JobPageListGetResultModel = {
    items: data.Data.data,
    total: data.Data.totals,
  };
  // data.Data.data.forEach(function(item) {
    
  //   defHttp.post(
  //     { url: Api.AddJob, params: genActionjob(item.JobType, item.AssemblyName,item.JobName,item.Triggers[0].Args) },
  //     {
  //       errorMessageMode: 'none',
  //       isTransformResponse: false,
  //     },
  //   );
  // });
  return model;
}

export const SaveTsk_Job = async (params: Tsk_JobListItem, isUpdate: boolean) => {
  let data;
  if (isUpdate) {
    params.uPeriod = params.Period
    data = await defHttp.post(
      { url: Api.UpdateJob, params: genAction('TSK_JOB',params)},
      {
        errorMessageMode: 'none',
        isTransformResponse: false,
        apiUrl: globSetting.taskApiUrl
      },
    );
  } else {
    params.ID = buildUUID(); //生成GUID
    data = await defHttp.post(
      { url: Api.AddJob, params: genActionjob(params.JobType, params.AssemblyName,params.JobName,params.Period,params.Remark) },
      {
        errorMessageMode: 'none',
        isTransformResponse: false,
        apiUrl: globSetting.taskApiUrl
      },
    );
    // //添加任务数据到数据库
    // data.Data.JobName=params.JobName;
    // data.Data.Remark=params.Remark;
    // data.Data.JobType=params.JobType;
    // var job=await defHttp.post(
    // {
    //   url:Api.AddEntity,params:genAction('TSK_JOB',data.Data)
    // },
    // {
    //   errorMessageMode:'none',
    //   isTransformResponse:false,
    //   apiUrl: globSetting.taskApiUrl
    // });
    // data.Data.Triggers[0].Args=params.Time*60*1000
    // data.Data.Triggers[0].JobId=data.Data.ID
    // var trig = defHttp.post(
    // {
    //   url:Api.AddEntity,params:genAction('TSK_TRIG',data.Data.Triggers[0])
    // },
    // {
    //   errorMessageMode:'none',
    //   isTransformResponse:false,
    //   apiUrl: globSetting.taskApiUrl
    // });
  }
  
  return data;
};
//删除
export const DeleteTsk_Job = async (params: Recordable) => {
  const usParams = genAction('TSK_JOB', [params]);
  const usParamstrig = genAction('TSK_TRIG', [params.Triggers]);
  defHttp.post({ url: Api.DeleteList, params: usParamstrig },
    {
      errorMessageMode: 'none',
      isTransformResponse: false,
      apiUrl: globSetting.taskApiUrl
    },);
  return await defHttp.post(
    { url: Api.DeleteList, params: usParams },
    {
      errorMessageMode: 'none',
      isTransformResponse: false,
      apiUrl: globSetting.taskApiUrl
    },
  );
};
//开始任务
export const StartTsk_Job = async (params: Recordable) => {
  const usParams = genAction('TSK_JOB', params.JobName);
  return await defHttp.post(
    { url: Api.StartJob, params: usParams },
    {
      errorMessageMode: 'none',
      isTransformResponse: false,
      apiUrl: globSetting.taskApiUrl
    },
  );
};
//停止任务
export const StopTsk_Job = async (params: Recordable) => {
  const usParams = genAction('TSK_JOB', params.JobName);
  return await defHttp.post(
    { url: Api.StopJob, params: usParams },
    {
      errorMessageMode: 'none',
      isTransformResponse: false,
      apiUrl: globSetting.taskApiUrl
    },
  );
};
//下拉列表
export const optionsListApi = async (params: Recordable) => {
  const usParams = genAction('TSK_TRIG+Statuss', "");
  return await defHttp.post(
    { url: Api.urlQueryEnum, params: usParams },
    {
      errorMessageMode: 'none',
      isTransformResponse: false,
      apiUrl: globSetting.taskApiUrl
    },
  );
};
